searchNodes=[{"doc":"Runbox allows working with scenario releases. It can load scenario releases and provide information about the individual scenarios within them.","ref":"Runbox.html","title":"Runbox","type":"module"},{"doc":"Generates initial state for run component on run slave node. Because function should be called from code implementing scenario type (for example stage based), returned value is also specific for scenario type.","ref":"Runbox.html#generate_state_for_run_component/2","title":"Runbox.generate_state_for_run_component/2","type":"function"},{"doc":"Retrieves information about scenarios in a release.","ref":"Runbox.html#get_release_scenarios/1","title":"Runbox.get_release_scenarios/1","type":"function"},{"doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.html#list_scenario_notification_channels/4","title":"Runbox.list_scenario_notification_channels/4","type":"function"},{"doc":"Lists all template languages defined for senario, notification type, template type and channel.","ref":"Runbox.html#list_scenario_notification_languages/5","title":"Runbox.list_scenario_notification_languages/5","type":"function"},{"doc":"Lists all template types of the specified notification.","ref":"Runbox.html#list_scenario_notification_template_types/3","title":"Runbox.list_scenario_notification_template_types/3","type":"function"},{"doc":"Lists all notification types for a scenario.","ref":"Runbox.html#list_scenario_notification_types/2","title":"Runbox.list_scenario_notification_types/2","type":"function"},{"doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel and language. If language is not defined or does not exist, fallback_language is used.","ref":"Runbox.html#load_and_eval_scenario_notification_templates/8","title":"Runbox.load_and_eval_scenario_notification_templates/8","type":"function"},{"doc":"Tries to load the notification spec of the given scenario. Returns {:ok, notification_spec} if the spec is found {:error, :cannot_load, exception} if the spec file cannot be found {:error, :bad_syntax, exception} if the spec file was found but contains syntactic errors","ref":"Runbox.html#load_scenario_notification_spec/2","title":"Runbox.load_scenario_notification_spec/2","type":"function"},{"doc":"Runs on_start function of scenario on run slave node.","ref":"Runbox.html#run_on_start/2","title":"Runbox.run_on_start/2","type":"function"},{"doc":"Saves entity state to state store running on run master node. This call is called from slave to master.","ref":"Runbox.html#save_entity/3","title":"Runbox.save_entity/3","type":"function"},{"doc":"Starts new environment for run. Every run runs on own slave node. Caller process is linked with supervisor started during this call. Started supervisor will supervise all run components running on slave node.","ref":"Runbox.html#start_link_run_environment/2","title":"Runbox.start_link_run_environment/2","type":"function"},{"doc":"Starts slave node for release in release_dir . If app_env is set, configured applications env variables are set on slave node (for example ui_url variable is needed to be set in toolbox application env if node is used for notifications evaluation, i.e. app_env must be set to [toolbox: [ui_url: &quot;https://some_url&quot;]] ).","ref":"Runbox.html#start_release_node/2","title":"Runbox.start_release_node/2","type":"function"},{"doc":"Starts scenario component on slave node.","ref":"Runbox.html#start_run_component/3","title":"Runbox.start_run_component/3","type":"function"},{"doc":"Decide if a message is a duplicate by comparing it to messages already seen. Only messages with the biggest timestamp are remembered as &quot;seen&quot;. If the actual message has lower timestamp than the messages in &quot;seen&quot;, it is considered &quot;old&quot;. If it has the exact same timestamp, it is compared for equality with all the &quot;seen&quot; messages and if it matches, it is considered &quot;duplicate&quot;. In any other case, the message is considered &quot;new&quot;.","ref":"Runbox.Deduplicator.html","title":"Runbox.Deduplicator","type":"module"},{"doc":"Decides if a given message is a duplicate or not. Returns a tuple with {msg_condition, deduplicator_state} where msg_condition can be one of: :new - message is new and was not yet seen. :old - message is older than the messages already seen. :duplicate - message is equal to one of the latest messages already seen.","ref":"Runbox.Deduplicator.html#deduplicate/2","title":"Runbox.Deduplicator.deduplicate/2","type":"function"},{"doc":"Initializes a deduplicator. stream is an enumerable (possibly empty), which contains messages with descending timestamps - from newest to oldest. It is used to initialize &quot;seen&quot; messages from messages which were already processed. extract_timestamp is a function which returns a timestamp for a given message.","ref":"Runbox.Deduplicator.html#new/2","title":"Runbox.Deduplicator.new/2","type":"function"},{"doc":"","ref":"Runbox.Deduplicator.html#t:t/0","title":"Runbox.Deduplicator.t/0","type":"opaque"},{"doc":"Utilities for communicating with master node from slave node","ref":"Runbox.Master.html","title":"Runbox.Master","type":"module"},{"doc":"Calls a function on the master. Calls MFA on the master . See :erpc.call/4 for details.","ref":"Runbox.Master.html#call/4","title":"Runbox.Master.call/4","type":"function"},{"doc":"Structure holding Runbox context of running slave node.","ref":"Runbox.RunContext.html","title":"Runbox.RunContext","type":"module"},{"doc":"Context of running run slave node. :master_node - master node of run :node - slave node of run :sup_pid - pid of supervisor (running on slave) for run components running on slave :save_entity_mf - callback definition (module and functin name) for saving entity state. Function is always called with 2 params: entity ( Runbox.StateStore.Entity.t/0 ) and savepoint timestamp.","ref":"Runbox.RunContext.html#t:t/0","title":"Runbox.RunContext.t/0","type":"type"},{"doc":"Module contains common functions called on run slave node.","ref":"Runbox.RunNode.html","title":"Runbox.RunNode","type":"module"},{"doc":"Starts run component under run scenario.","ref":"Runbox.RunNode.html#start_run_component/3","title":"Runbox.RunNode.start_run_component/3","type":"function"},{"doc":"Starts supervisor for run. All components of run running on slave node will run under this supervisor. OneForAll strategy with 0 max restart stops supervisor if any component crashes. Because run manager process running on master is linked with this supervisor, it also crashes (and it what we want).","ref":"Runbox.RunNode.html#start_run_sup/1","title":"Runbox.RunNode.start_run_sup/1","type":"function"},{"doc":"Structure holding context of starting run. This structure is passed as param to every run component start.","ref":"Runbox.RunStartContext.html","title":"Runbox.RunStartContext","type":"module"},{"doc":"Adds pid of component identified by name to context.","ref":"Runbox.RunStartContext.html#add_component/3","title":"Runbox.RunStartContext.add_component/3","type":"function"},{"doc":"Returns pid of component identitfied by name .","ref":"Runbox.RunStartContext.html#component_pid/2","title":"Runbox.RunStartContext.component_pid/2","type":"function"},{"doc":"Currently context holds only mapping of names to pids of already started components.","ref":"Runbox.RunStartContext.html#t:t/0","title":"Runbox.RunStartContext.t/0","type":"type"},{"doc":"Component network builds and validates template dependency network. To build this network, module uses Toolbox.Scenario.Template.StageBased.subscriptions/0 . Only templates are defined at first, logic than derive input-topic nodes, timezip where one template subscribes to two stream, and output sink in the end.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html","title":"Runbox.Runtime.Stage.ComponentNetwork","type":"module"},{"doc":"Creates base network with only template nodes","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#convert_to_network/1","title":"Runbox.Runtime.Stage.ComponentNetwork.convert_to_network/1","type":"function"},{"doc":"Main function. Given list of template modules, expands them into components network with input streams, timezips etc... Options :direct_ticking - if true (default), creates network using direct ticking","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#create/2","title":"Runbox.Runtime.Stage.ComponentNetwork.create/2","type":"function"},{"doc":"Return all input topic names that are being subscribed to in component network.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#input_topics/1","title":"Runbox.Runtime.Stage.ComponentNetwork.input_topics/1","type":"function"},{"doc":"Sorts components (keys) of component network topologicaly, but according to backward edges, because edge means subscription relation (not comes after but comes before). So instead of indegree implementation use outdegee. Its wrath of kahn's algorithm.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#topology_sort/1","title":"Runbox.Runtime.Stage.ComponentNetwork.topology_sort/1","type":"function"},{"doc":"Full representation of particular component.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component/0","title":"Runbox.Runtime.Stage.ComponentNetwork.component/0","type":"type"},{"doc":"Part of component identifier.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component_type/0","title":"Runbox.Runtime.Stage.ComponentNetwork.component_type/0","type":"type"},{"doc":"Subscription edge defined with destination and props.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription/0","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription/0","type":"type"},{"doc":"Additional properties of subscription/edge. E.g. selector for Broadcast dispatcher.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription_properties/0","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription_properties/0","type":"type"},{"doc":"Component network is adjacency graph with subscription edges.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:t/0","title":"Runbox.Runtime.Stage.ComponentNetwork.t/0","type":"type"},{"doc":"Sandbox is helper for executing runs without started Altworx application. Sandbox can be used for scenarios unit testing and also for interactive development of scenarios. When used for unit testing, it can be used directly or via Runbox.Runtime.Stage.Sandbox.TestRunner . For interactive development of scenarios, run iex --erl &quot;-runbox mode slave&quot; -S mix from command line in your scenarios application root directory and then use Sandbox fuctions to execute your runs (of course use recompile before run execution if you changed scenario code).","ref":"Runbox.Runtime.Stage.Sandbox.html","title":"Runbox.Runtime.Stage.Sandbox","type":"module"},{"doc":"Starts new run for scenario_id and waits until all input messages are processed. Returns all output actions generated by run execution. Input messages for each runtime topic used by scenario should be defined in topics argument. Undefined topics are considered empty. Messages in each topic must be in ascending order by timestamp . Optionally user can specify list of modules containing scenarios (manifests, templates). If list of modules is specified execute_run does not search scenario in :scenarios application release, but in given modules. It opens possibility to write ad-hoc scenarios with only dependency on Runbox application, for example use it in Livebook . To see example of such livebook just run livebook server --home . in runbox root directory, go to generated livebook server link in browser and finally open sandbox-scenario-demo.livemd document. Running docker or altworx is not needed, only runbox app (and its deps) is required!","ref":"Runbox.Runtime.Stage.Sandbox.html#execute_run/3","title":"Runbox.Runtime.Stage.Sandbox.execute_run/3","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topic_name/0","title":"Runbox.Runtime.Stage.Sandbox.topic_name/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topics/0","title":"Runbox.Runtime.Stage.Sandbox.topics/0","type":"type"},{"doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe","type":"module"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#component_name/1","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_name/1","type":"function"},{"doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#create/1","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.create/1","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component/0","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component_network/0","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_network/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:subscription/0","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.subscription/0","type":"type"},{"doc":"For new unit testing of scenarios it is recommended to use functions in Runbox.Runtime.Stage.Sandbox directly. This module should only help to convert old scenarios integration tests (using Solutions.TestRunner) to unit tests. For examples of such conversion see tests in the scenarios master branch.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html","title":"Runbox.Runtime.Stage.Sandbox.TestRunner","type":"module"},{"doc":"Runs an unit test according to the test_def definition. Function accepts the same test_def definition as Solutions.TestRunner.run_test/1 with few differences: Only run_options.scenario_id , messages and expected_actions properties are used, other properties are ignored. Instead of output log format expected_actions are Toolbox.Scenario.OutputAction structures, for example %{ action : :add_asset , params : %{ attributes : %{ } , id : &quot;/diamonds/O&quot; } , result : &quot;nil&quot; , serialization_vector : [ &quot;/diamonds/O&quot; ] , side_effects : false , timestamp : 1 } must be changed to: % OutputAction { type : :add_asset , body : % Asset { attributes : %{ } , id : &quot;/diamonds/O&quot; } , svector : [ &quot;/diamonds/O&quot; ] , timestamp : 1 } To see differences take a look at deduplication_diamond_test.exs in scenarios and the same test in solutions.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html#run_test/1","title":"Runbox.Runtime.Stage.Sandbox.TestRunner.run_test/1","type":"function"},{"doc":"Selector function generator which is used to filter messages between GenStage phases. Stage based runtime uses BroadcastDispatcher to dispatch messages between TemplateCarriers, this kind of dispatcher support message selector function to be passed as part of GenStage subscription. This module is used to generate this function based on template configuration.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html","title":"Runbox.Runtime.Stage.SelectorBuilder","type":"module"},{"doc":"Builds GenStages BroadcastDispatcher filter function based on template configuration. Filter function is produced based on Toolbox.Scenario.Template.StageBased.subscriptions/0 callback result. Subscription is defined as {message_type, _routing_rule}, we use only message_type part of subscription. All message types are stored in produced function clojure and dispatched message type is matched against them. Exception to the message type matching are output actions and tick messages which are always matched.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html#build/1","title":"Runbox.Runtime.Stage.SelectorBuilder.build/1","type":"function"},{"doc":"Module generates state of run components running on slave node.","ref":"Runbox.Runtime.Stage.StateGenerator.html","title":"Runbox.Runtime.Stage.StateGenerator","type":"module"},{"doc":"Generates state for component template.","ref":"Runbox.Runtime.Stage.StateGenerator.html#generate_for_component/2","title":"Runbox.Runtime.Stage.StateGenerator.generate_for_component/2","type":"function"},{"doc":"Module implements producer_consumer GenStage behaviour, scenario template is used to handle events Every scenario template is represented in stage based runtime by this module. TemplateCarrier uses Runbox.Runtime.Stage.UnitRegistry as its state (packed in Runbox.StateStore.Entity envelope for StateStore usage). UnitRegistry provides functionality to lookup units via subscriptions defined in scenario template. If unit is located for given message, Toolbox.Scenario.Template.StageBased.handle_message/2 is used to handle this message. When there is no registered unit for given routing key, Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1 is used instead. The state is updated in Runbox.StateStore.Entity with Runbox.StateStore.Entity.update_state/3 after every message is processed. Additionally, before a message is processed it is confirmed that all messages with lower timestamps were processed. This is done with Runbox.StateStore.Entity.ack_processed_time/3 and can result in saving the state in state store.","ref":"Runbox.Runtime.Stage.TemplateCarrier.html","title":"Runbox.Runtime.Stage.TemplateCarrier","type":"module"},{"doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#component_name/1","title":"Runbox.Runtime.Stage.TemplateCarrier.component_name/1","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#start_link/3","title":"Runbox.Runtime.Stage.TemplateCarrier.start_link/3","type":"function"},{"doc":"Module encapsulates scenario template callback calls. Scenario defines Toolbox.Runtime.Stage.Unit as state carrier, these units are organized into Runbox.Runtime.Stage.UnitRegistry which is helper structure to route messages between units managed by one template. Messages are handled via Toolbox.Scenario.Template.StageBased callbacks. We distinguish two types of messages = message to existing unit and message to new unit (asset discovery). Messages that doesn't have any unit registered and thus found to handle them, we call this situation asset discovery and use Toolbox.Scenario.Template.StageBased.handle_asset_discovery/1 callback to handle these message. New unit may or may not be created here, but when it does, it needs to be initialized via Toolbox.Scenario.Template.StageBased.init/2 callback. When there is at least one unit which is registered to the message, we use callback Toolbox.Scenario.Template.StageBased.handle_message/2 . Unit may be updated or stopped here. We support timeouts to be defined. These timeouts are triggered via external time, which is derived from incomming message timestamps. Timeouts are registered for one unit. Some output actions produced by any of template callback should be further updated. Events require filling run id and notifications require scenario id to be filled.","ref":"Runbox.Runtime.Stage.TemplateImpl.html","title":"Runbox.Runtime.Stage.TemplateImpl","type":"module"},{"doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#handle_message/6","title":"Runbox.Runtime.Stage.TemplateImpl.handle_message/6","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#init_state/5","title":"Runbox.Runtime.Stage.TemplateImpl.init_state/5","type":"function"},{"doc":"Timezip component responsible for merging messages from multiple sources using message timestamps.","ref":"Runbox.Runtime.Stage.Timezip.html","title":"Runbox.Runtime.Stage.Timezip","type":"module"},{"doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#component_name/1","title":"Runbox.Runtime.Stage.Timezip.component_name/1","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#start_link/3","title":"Runbox.Runtime.Stage.Timezip.start_link/3","type":"function"},{"doc":"Buffering multi-queue data structure for Timezip. If the structure would be heap, the complexity would be Olog(N) where N is number of messages (topped by max demand). With multi-queue operation is ~ O(M) where M is number of producers.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html","title":"Runbox.Runtime.Stage.Timezip.MultiQueue","type":"module"},{"doc":"Adds new queue to MultiQueue. If adding same id again -&gt; clears buffered messages for given producer.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#add_queue/2","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.add_queue/2","type":"function"},{"doc":"Main logic, will return messages from all queues zipped/sorted by min timestamp. Will return as many messages as posible, until some queue is empty. In returned tuple, returned values means: multi_queue: multi-queue without emitted messages demand_distribution: map with id -&gt; integer() , meaning how many messages in output originates from particular queue id, can be used for manual demand handling in genstage emitted: returned messages from multiqueue front","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#dequeue_all/2","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.dequeue_all/2","type":"function"},{"doc":"Adds messages for queue id to multiqueue.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#enqueue/3","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.enqueue/3","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#new/0","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.new/0","type":"function"},{"doc":"Removes queue and its content from multi_queue","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#remove_queue/2","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.remove_queue/2","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:demand_distribution/0","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.demand_distribution/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:t/0","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.t/0","type":"type"},{"doc":"Unit register used in stage based runtime to manage state of units. UnitRegistry is configured via Toolbox.Scenario.Template.StageBased.subscriptions/0 callback result. Callback returns template subscriptions, each subscription is defined as {message_type, routing_rule}. Unit registry contains one register per configured message_type. Routing rule is used to store unit and later on lookup this unit when needed. Units are being registered using unit attributes as defined in routing_rule. Unit lookup uses routing_rule to parse message body and the result compares to stored unit attributes.","ref":"Runbox.Runtime.Stage.UnitRegistry.html","title":"Runbox.Runtime.Stage.UnitRegistry","type":"module"},{"doc":"Returns unit with given id.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#get_unit/2","title":"Runbox.Runtime.Stage.UnitRegistry.get_unit/2","type":"function"},{"doc":"Initialize UnitRegistry non-persisted fields. This needs to be called right before starting new unit registry (done in new/1 automatically) and also after loading UnitRegistry from savepoint. This is needed because not all fields are persisted into a savepoint.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#init/1","title":"Runbox.Runtime.Stage.UnitRegistry.init/1","type":"function"},{"doc":"Searches for registered unit in the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#lookup/2","title":"Runbox.Runtime.Stage.UnitRegistry.lookup/2","type":"function"},{"doc":"Creates new unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#new/1","title":"Runbox.Runtime.Stage.UnitRegistry.new/1","type":"function"},{"doc":"Returns first reached timeout and removes it from unit registry in one operation.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#pop_reached_timeout/2","title":"Runbox.Runtime.Stage.UnitRegistry.pop_reached_timeout/2","type":"function"},{"doc":"Registers given unit to the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register/2","title":"Runbox.Runtime.Stage.UnitRegistry.register/2","type":"function"},{"doc":"Registers timeout.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register_timeout/4","title":"Runbox.Runtime.Stage.UnitRegistry.register_timeout/4","type":"function"},{"doc":"Reregisters unit in the unit registry. Function updates alternative registers using new version of unit attributes. Timeouts will remain untouched.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#reregister/2","title":"Runbox.Runtime.Stage.UnitRegistry.reregister/2","type":"function"},{"doc":"Unregisters given unit from the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#unregister/2","title":"Runbox.Runtime.Stage.UnitRegistry.unregister/2","type":"function"},{"doc":"Updates unit in unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#update/2","title":"Runbox.Runtime.Stage.UnitRegistry.update/2","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:msg_parser/0","title":"Runbox.Runtime.Stage.UnitRegistry.msg_parser/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:path/0","title":"Runbox.Runtime.Stage.UnitRegistry.path/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key/0","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key_def/0","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key_def/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:t/0","title":"Runbox.Runtime.Stage.UnitRegistry.t/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_id/0","title":"Runbox.Runtime.Stage.UnitRegistry.unit_id/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_register/0","title":"Runbox.Runtime.Stage.UnitRegistry.unit_register/0","type":"type"},{"doc":"Module manages alternative registry state. Every unit is registered only once per alternative registry. More than one unit can be registered with the same key.","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry","type":"module"},{"doc":"Get registered unit ids","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#lookup/2","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.lookup/2","type":"function"},{"doc":"Returns new alternative registry","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#new/0","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.new/0","type":"function"},{"doc":"Registers unit in alternative reg with given key","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#register_unit/3","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.register_unit/3","type":"function"},{"doc":"Unregisters unit from alternative reg","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#unregister_unit/2","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unregister_unit/2","type":"function"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:registration_key/0","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.registration_key/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:t/0","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.t/0","type":"type"},{"doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:unit_id/0","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unit_id/0","type":"type"},{"doc":"Builder of msg_parser and unit_register fns used in Runbox.Runtime.Stage.UnitRegistry message_parser is lambda function used to parse Toolbox.Message and creates key to find unit in unit registry unit_register is lambda function used to parse Toolbox.Runtime.Stage.Unit and creates key to store unit in unit registry","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder","type":"module"},{"doc":"Gets routing key definition as argument and returns msg_parser lambda function Lambda takes Toolbox.Message as argument and returns list of message body values based on provided routing key definition. iex&gt; msg_parser_fn = ...&gt; RoutingKeyBuilder.build_msg_parser({:=, [[:foo]], [[:bar]]}) ...&gt; msg_parser_fn.(%Message{body: %{foo: &quot;message_body_key_value&quot;}}) [&quot;message_body_key_value&quot;] iex&gt; msg_parser_fn = ...&gt; RoutingKeyBuilder.build_msg_parser({:in, [[:foo]], [[:bar]]}) ...&gt; msg_parser_fn.(%Message{body: %{foo: &quot;message_body_key_value&quot;}}) [&quot;message_body_key_value&quot;]","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_msg_parser/1","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_msg_parser/1","type":"function"},{"doc":"Gets routing key definition as argument and returns unit_register lambda function Lambda takes alternative registers (unit indexes), alternative register name, Toolbox.Runtime.Stage.Unit as arguments and returns updated alternative registers based on provided routing key definition. iex&gt; unit_register_fn = ...&gt; RoutingKeyBuilder.build_unit_register({:=, [[:foo]], [[:bar]]}) ...&gt; unit = %Unit{id: &quot;unit_id&quot;, attributes: %{bar: &quot;attribute_key_value&quot;}} ...&gt; unit_register_fn.(%{&quot;alt_reg&quot; =&gt; AlternativeRegistry.new()}, &quot;alt_reg&quot;, unit) %{&quot;alt_reg&quot; =&gt; %{[&quot;attribute_key_value&quot;] =&gt; [&quot;unit_id&quot;]}} iex&gt; unit_register_fn = ...&gt; RoutingKeyBuilder.build_unit_register({:in, [[:foo]], [[:bar]]}) ...&gt; unit = %Unit{id: &quot;unit_id&quot;, attributes: %{bar: [&quot;value_1&quot;, &quot;value_2&quot;]}} ...&gt; unit_register_fn.(%{&quot;alt_reg&quot; =&gt; AlternativeRegistry.new()}, &quot;alt_reg&quot;, unit) %{&quot;alt_reg&quot; =&gt; %{[&quot;value_1&quot;] =&gt; [&quot;unit_id&quot;], [&quot;value_2&quot;] =&gt; [&quot;unit_id&quot;]}}","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_unit_register/1","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_unit_register/1","type":"function"},{"doc":"Holds information about scenario.","ref":"Runbox.Scenario.html","title":"Runbox.Scenario","type":"module"},{"doc":"","ref":"Runbox.Scenario.html#t:component_def/0","title":"Runbox.Scenario.component_def/0","type":"type"},{"doc":"","ref":"Runbox.Scenario.html#t:t/0","title":"Runbox.Scenario.t/0","type":"type"},{"doc":"Module contains functions for working with scenario notifications.","ref":"Runbox.Scenario.Notification.html","title":"Runbox.Scenario.Notification","type":"module"},{"doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.Scenario.Notification.html#list_channels/3","title":"Runbox.Scenario.Notification.list_channels/3","type":"function"},{"doc":"Lists all template languages defined for senario, notification type, template type and channel.","ref":"Runbox.Scenario.Notification.html#list_languages/4","title":"Runbox.Scenario.Notification.list_languages/4","type":"function"},{"doc":"Lists all notification types for a scenario.","ref":"Runbox.Scenario.Notification.html#list_notification_types/1","title":"Runbox.Scenario.Notification.list_notification_types/1","type":"function"},{"doc":"Lists all template types of the specified notification.","ref":"Runbox.Scenario.Notification.html#list_template_types/2","title":"Runbox.Scenario.Notification.list_template_types/2","type":"function"},{"doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel and language. If language is not defined or does not exist, fallback_language is used.","ref":"Runbox.Scenario.Notification.html#load_and_eval_templates/7","title":"Runbox.Scenario.Notification.load_and_eval_templates/7","type":"function"},{"doc":"Tries to load the notification spec of the given scenario. Returns {:ok, notification_spec} if the spec is found {:error, :cannot_load, exception} if the spec file cannot be found {:error, :bad_syntax, exception} if the spec file was found but contains syntactic errors","ref":"Runbox.Scenario.Notification.html#load_spec/1","title":"Runbox.Scenario.Notification.load_spec/1","type":"function"},{"doc":"Struct representing scenario module.","ref":"Runbox.Scenario.Template.html","title":"Runbox.Scenario.Template","type":"module"},{"doc":"","ref":"Runbox.Scenario.Template.html#t:t/0","title":"Runbox.Scenario.Template.t/0","type":"type"},{"doc":"Module for inspecting a scenario release.","ref":"Runbox.ScenarioRelease.html","title":"Runbox.ScenarioRelease","type":"module"},{"doc":"Retrieves information about scenarios in a release.","ref":"Runbox.ScenarioRelease.html#release_info/1","title":"Runbox.ScenarioRelease.release_info/1","type":"function"},{"doc":"Functions which are called on the scenario slave via RPC from the master node.","ref":"Runbox.ScenarioRelease.SlaveFunc.html","title":"Runbox.ScenarioRelease.SlaveFunc","type":"module"},{"doc":"","ref":"Runbox.ScenarioRelease.SlaveFunc.html#release_info/1","title":"Runbox.ScenarioRelease.SlaveFunc.release_info/1","type":"function"},{"doc":"Returns list of scenarios in release.","ref":"Runbox.ScenarioRelease.SlaveFunc.html#scenarios/0","title":"Runbox.ScenarioRelease.SlaveFunc.scenarios/0","type":"function"},{"doc":"Holds information about scenario template.","ref":"Runbox.ScenarioTemplate.html","title":"Runbox.ScenarioTemplate","type":"module"},{"doc":"","ref":"Runbox.ScenarioTemplate.html#t:t/0","title":"Runbox.ScenarioTemplate.t/0","type":"type"},{"doc":"Utilities for starting a slave node with a scenario release and communicating with the node.","ref":"Runbox.Slave.html","title":"Runbox.Slave","type":"module"},{"doc":"Calls a function on the slave. Calls MFA on the slave . See :erpc.call/4 for details.","ref":"Runbox.Slave.html#call/4","title":"Runbox.Slave.call/4","type":"function"},{"doc":"Starts a slave node. The release_dir is a directory with scenario release. If app_env is set, given app environment variables are set on slave.","ref":"Runbox.Slave.html#start/2","title":"Runbox.Slave.start/2","type":"function"},{"doc":"Spawns a slave and executes the fun . fun recives the slave node as a parameter. The slave is terminated after the fun finishes.","ref":"Runbox.Slave.html#with_slave/2","title":"Runbox.Slave.with_slave/2","type":"function"},{"doc":"Module defines struct which acts as state store envelope for any stateful runtime component.","ref":"Runbox.StateStore.Entity.html","title":"Runbox.StateStore.Entity","type":"module"},{"doc":"Confirm that all messages with lower timestamps were processed. When the timestamp is higher than next savepoint the state is persisted into StateStore with StateStore.save/4 and next savepoint target is determined and stored in the entity. The state is persisted only once per every savepoint.","ref":"Runbox.StateStore.Entity.html#ack_processed_time/3","title":"Runbox.StateStore.Entity.ack_processed_time/3","type":"function"},{"doc":"Returns entity id","ref":"Runbox.StateStore.Entity.html#id/1","title":"Runbox.StateStore.Entity.id/1","type":"function"},{"doc":"Creates new state store entity","ref":"Runbox.StateStore.Entity.html#new/5","title":"Runbox.StateStore.Entity.new/5","type":"function"},{"doc":"Returns entity schedule","ref":"Runbox.StateStore.Entity.html#schedule/1","title":"Runbox.StateStore.Entity.schedule/1","type":"function"},{"doc":"Returns entity state","ref":"Runbox.StateStore.Entity.html#state/1","title":"Runbox.StateStore.Entity.state/1","type":"function"},{"doc":"Returns entity timestamp","ref":"Runbox.StateStore.Entity.html#timestamp/1","title":"Runbox.StateStore.Entity.timestamp/1","type":"function"},{"doc":"Set entity state at the specified point in time.","ref":"Runbox.StateStore.Entity.html#update_state/3","title":"Runbox.StateStore.Entity.update_state/3","type":"function"},{"doc":"","ref":"Runbox.StateStore.Entity.html#t:id/0","title":"Runbox.StateStore.Entity.id/0","type":"type"},{"doc":"","ref":"Runbox.StateStore.Entity.html#t:state/0","title":"Runbox.StateStore.Entity.state/0","type":"type"},{"doc":"","ref":"Runbox.StateStore.Entity.html#t:t/0","title":"Runbox.StateStore.Entity.t/0","type":"type"},{"doc":"Module contains functions to compute savepoint timestamps. Savepoint timestamps are calculated as multiples of schedule .","ref":"Runbox.StateStore.ScheduleUtils.html","title":"Runbox.StateStore.ScheduleUtils","type":"module"},{"doc":"Returns next savepoint based on given schedule and timestamp . Next savepoint is calculated as next multiple of schedule larger or equal to given timestamp . Examples iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 0 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 10_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . next_savepoint ( 60_000 , 60_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#next_savepoint/2","title":"Runbox.StateStore.ScheduleUtils.next_savepoint/2","type":"function"},{"doc":"Returns previous savepoint based on given schedule and timestamp . Next savepoint is calculated as previous multiple of schedule lower or equal to given timestamp . Examples iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 30_000 ) 0 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 60_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 90_000 ) 60_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 120_000 ) 120_000 iex&gt; Runbox.StateStore.ScheduleUtils . previous_savepoint ( 60_000 , 150_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#previous_savepoint/2","title":"Runbox.StateStore.ScheduleUtils.previous_savepoint/2","type":"function"},{"doc":"Returns unreached savepoints based on given schedule in range of given timestamps (from; to&gt; Examples iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 0 , 120_000 ) [ 60_000 , 120_000 ] iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 60_000 , 120_000 ) [ 120_000 ] iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints ( 60_000 , 60_000 , 180_000 ) [ 120_000 , 180_000 ]","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints/3","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints/3","type":"function"},{"doc":"Returns count of unreached savepoints. Examples iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 60_000 , 0 , 120_000 ) 2 iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 60_000 , 60_000 , 120_000 ) 1 iex&gt; Runbox.StateStore.ScheduleUtils . unreached_savepoints_count ( 1 , 0 , 120_000 ) 120_000","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints_count/3","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints_count/3","type":"function"},{"doc":"Timestamp defined as unix epoch in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms/0","title":"Runbox.StateStore.ScheduleUtils.epoch_ms/0","type":"type"},{"doc":"Difference between two unix epoch timestamps in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms_interval/0","title":"Runbox.StateStore.ScheduleUtils.epoch_ms_interval/0","type":"type"},{"doc":"Interval (in seconds) between savepoint timestamps.","ref":"Runbox.StateStore.ScheduleUtils.html#t:schedule/0","title":"Runbox.StateStore.ScheduleUtils.schedule/0","type":"type"}]